=== debian/changelog ===
frama-c (20161101+silicon+dfsg-5) unstable; urgency=medium

  * Add Breaks/Replaces frama-c-base (<= 20140301+neon+dfsg-3) to
    frama-c (Closes: #851104)

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 15 Jan 2017 13:00:55 +0100

frama-c (20161101+silicon+dfsg-4) unstable; urgency=medium

  * Fix FTBFS by avoiding use of PWD variable in Makefile
    - Update patch 0005-Value.cmo-needs-LoopAnalysis.cmo.patch

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 01 Jan 2017 17:28:41 +0100

frama-c (20161101+silicon+dfsg-3) unstable; urgency=medium

  * Fix typo in Vcs-Browser field
  * Install frama-c-config utility in frama-c-base
  * Clean up content of filtered files from debian/gbp.conf
  * Avoid double linking of LoopAnalysis.cmo
  * ocaml-findlib is not needed for frama-c-base. It has a runtime dependency
    on libfindlib-ocaml which is enough.
  * Re-enable Impact plugin by dropping --disable-impact flag for configure
    script. The plugin used to be non open-source, which is not the case
    anymore.
  * Drop configure flag --disable-security as it became useless.
  * configure script is now able to find zarith correctly. The use of
    --enable-zarith=<path> is not needed anymore. Thus, dropping it.

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 01 Jan 2017 00:37:33 +0100

frama-c (20161101+silicon+dfsg-2) unstable; urgency=medium

  * Disable apron
  * Add ocaml-findlib as a dependency for frama-c-base
  * Fix build on bytecode architectures
    - add patch debian/patches/0005-Add-a-section-for-LoopAnalysis-plugin.patch
    - add patch debian/patches/0006-gui.byte-needs-TARGETS_GUI_BYTE-only.patch

 -- Mehdi Dogguy <mehdi@debian.org>  Wed, 21 Dec 2016 14:17:38 +0100

frama-c (20161101+silicon+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Refresh patches
    - Drop patch 0004-Don-t-fail-during-the-configure-on-bytecode-architec.patch
      (not needed anymore)
    - Add patch 0004-Use-ocamlfind-package-lablgtk2-gnome.gnomecanvas.patch
  * Add libapron-ocaml-dev to Build-Depends
  * Do not recommend why and libwhy-coq which are not part of Stretch
  * Install plugins/top in frama-c-base
  * Enhance package description
  * Remove obsolete Breaks/Replaces statements
  * Use canonical and secure URIs for Vcs-{Browser,Git} fields
  * Bump Standards-Version to 3.9.8, no changes required
  * Bump DH compat to 9

 -- Mehdi Dogguy <mehdi@debian.org>  Tue, 13 Dec 2016 00:32:12 +0100
