## frama-c 20170501+phosphorus+dfsg

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #                                                                        #
 #  This file is part of Frama-C.                                         #
 #                                                                        #
-#  Copyright (C) 2007-2016                                               #
+#  Copyright (C) 2007-2017                                               #
 #    CEA (Commissariat à l'énergie atomique et aux énergies              #
 #         alternatives)                                                  #
 #                                                                        #
@@ -126,6 +126,13 @@
 
 DOC_FLAGS= -colorize-code -stars -m A -hide-warnings $(PACKAGES) $(INCLUDES) $(GUI_INCLUDES)
 
+# Files that depend on external libraries -namely Zarith- whose interface
+# has not been explicitely declared -opaque, hence would trigger warning 58.
+# This can't be solve by Frama-C itself, we can only wait for an update of
+# said library.
+
+NON_OPAQUE_DEPS:=
+
 # Libraries generated by Frama-C
 GEN_BYTE_LIBS=
 GEN_OPT_LIBS=
@@ -223,7 +230,8 @@
       Changelog config.h.in						\
       VERSION $(wildcard licenses/*)                                    \
       $(LIBC_FILES)							\
-      $(wildcard share/emacs/*.el) share/configure.ac                   \
+      $(wildcard share/emacs/*.el) share/autocomplete_frama-c           \
+      share/configure.ac                                                \
       share/Makefile.config.in share/Makefile.common                    \
       share/Makefile.generic						\
       share/Makefile.plugin.template share/Makefile.dynamic		\
@@ -233,9 +241,7 @@
 	  $(wildcard src/kernel_internals/runtime/*.ml*))               \
       $(wildcard src/kernel_services/abstract_interp/*.ml*)             \
       $(wildcard src/plugins/gui/*.ml*)                                 \
-      $(filter-out src/libraries/stdlib/integer.ml                      \
-	src/libraries/stdlib/FCDnlink.ml,                               \
-	$(wildcard src/libraries/stdlib/*.ml*))                         \
+      $(wildcard src/libraries/stdlib/*.ml*)                            \
       $(wildcard src/libraries/utils/*.ml*)                             \
       $(wildcard src/libraries/utils/*.c)                               \
       $(wildcard src/libraries/project/*.ml*)                           \
@@ -313,11 +319,3 @@
 	fi
 	$(RM) $@.tmp
 	touch $@.tmp
-	$(foreach dir,$(EXTERNAL_PLUGINS),\
-		if test -d $(dir)/share; then \
-			echo "Sharing $(dir)/link"; \
-			ln -s $(realpath $(dir)/share) share/$(notdir $(dir)); \
-			echo /$(notdir $(dir)) >> $@.tmp; \
-		fi; )
-	mv $@.tmp $@
-
