=== debian/changelog ===
frama-c (20170501+phosphorus+dfsg-2build1) bionic; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 28 Oct 2017 16:39:11 +0200

frama-c (20170501+phosphorus+dfsg-2) unstable; urgency=medium

  * Fix typo in patch 0006-gui.byte-needs-TARGETS_GUI_BYTE-only.patch
  * Add zsh completion file from upstream's repository
    - add 0010-Add-zsh-completion-file.patch
  * Better dynlink detection in configure script (Closes: #871912)
    - add 0009-Better-handling-of-dynlink-detection.patch
  * Fix install target in Makefile to avoid trying to install native
    objects on bytecode architectures
  * Do not use '-C' CPPFLAG when compiling jemalloc, as math.h bombs out
    with -C on i386. (Closes: #874273, LP: #1714514). Thanks to Dimitri
    John Ledkov for the patch.

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 10 Sep 2017 13:52:22 +0200

frama-c (20170501+phosphorus+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Update copyright file
  * Refresh patches
  * Add patch to fix more spelling errors
    - add 0008-More-fixes-of-spelling-errors.patch
  * Add references to upstream bugs for some patches

 -- Mehdi Dogguy <mehdi@debian.org>  Fri, 11 Aug 2017 14:06:33 -0400

frama-c (20161101+silicon+dfsg-6) unstable; urgency=medium

  * Team upload
  * Fix FTBFS with OCaml 4.05.0 (Closes: #843020)

 -- Stéphane Glondu <glondu@debian.org>  Thu, 27 Jul 2017 19:03:40 +0200
